void *memset(void *s, int c, int n)
{
  unsigned char *p = (unsigned char *)s;

  while (n--)
    *p++ = c;

  return s;
}

void *memcpy(void *dest, const void *src, int n)
{
  unsigned char *p = (unsigned char *)dest, *s = (unsigned char *)src;

  while (n--)
    *p++ = *s++;

  return dest;
}

int memcmp (const void *s1, const void *s2, int n)
{
  unsigned char *p = (unsigned char *)s1, *s = (unsigned char *)s2;
  int r;

  while (n--)
    {
      r = *p++ - *s++;
      if (r)
	return r;
    }

  return 0;
}

int strnlen (const unsigned char *s, int maxlen)
{
  int i;

  for (i=0; i<maxlen; i++)
    if (s[i] == 0)
      return i;

  return maxlen;
}

int strlen (const unsigned char *s)
{
  int i;

  for (i=0; 1; i++)
    if (s[i] == 0)
      return i;
}
