struct ipv6_addr { u8 bits[16]; };
#define IPv6_ADDRSIZE	(sizeof (struct ipv6_addr))

extern struct ipv6_addr node_ipv6_addr;

extern int net6_address_autoconfig (struct eth_packet *p);

extern int ping6 (struct eth_packet *p, const struct eth_addr *dst_eth_addr,
		  const struct ipv6_addr *dst_ip_addr_p, int count);

extern int dhcp6 (struct eth_packet *p, struct ipv6_addr *dns_ipv6_addr_p);

int dns_resolv6 (struct eth_packet *p,
		 const struct eth_addr *dst_eth_addr,
		 const struct ipv6_addr *server_ip_addr_p,
		 const char *hostname, struct ipv6_addr *target_ipv6_addr_p);

extern struct eth_addr *ipv6_get_route (struct eth_packet *p,
					const struct ipv6_addr *target);

extern int tcp_maton6 (struct eth_packet *p,
		       const struct eth_addr *dst_eth_addr,
		       const struct ipv6_addr *server_ip_addr_p,
		       u16 server_port, u16 my_port,
		       u8 *send, int send_size,
		       u8 *receive, int receive_size);
